package benchmarkRMI;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class BenchmarkRMIImpl extends UnicastRemoteObject implements
		BenchmarkRMI {

	private static final long serialVersionUID = -1840006586937276141L;

	protected BenchmarkRMIImpl() throws RemoteException {
	}

	private String[] _fields = null;

	public String getField(int index) {
		return _fields[index];
	}

	public static void main(String[] args) {
		try {
			BenchmarkRMI obj = new BenchmarkRMIImpl();
			Naming.rebind("benchmark", obj);
			System.out.println("benchmark begin.");
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
	}

	public void createField(int powerOf2) throws RemoteException {
		_fields = new String[1 << powerOf2];
		for (int i = 0; i < 1 << powerOf2; ++i)
			_fields[i] = new String("field" + i);
	}

	public void setField(int index, String str) throws RemoteException {
		_fields[index] = str;
	}

	public void noop() throws RemoteException {
		return;
	}
}
